(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs/operators')) :
	typeof define === 'function' && define.amd ? define('@webdev-tools/ng-nested-reactive-forms', ['exports', '@angular/core', '@angular/forms', 'rxjs/operators'], factory) :
	(factory((global['webdev-tools'] = global['webdev-tools'] || {}, global['webdev-tools']['ng-nested-reactive-forms'] = {}),global.ng.core,global.ng.forms,global.Rx.Observable.prototype));
}(this, (function (exports,core,forms,operators) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */










function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var NrfNestedFormService = /** @class */ (function () {
    function NrfNestedFormService() {
        this.submit$ = new core.EventEmitter();
        this.formGroup = new forms.FormGroup({});
    }
    Object.defineProperty(NrfNestedFormService.prototype, "entity", {
        get: function () {
            return this.entityInternal;
        },
        set: function (entity) {
            this.entityInternal = entity;
            this.formData = this.cloneDeep(entity);
        },
        enumerable: true,
        configurable: true
    });
    NrfNestedFormService.prototype.cloneDeep = function (target) {
        var _this = this;
        if (!target || typeof target !== 'object') {
            return target;
        }
        if (target instanceof Date) {
            return new Date(target);
        }
        if (Array.isArray(target)) {
            return target.map(function (value) { return _this.cloneDeep(value); });
        }
        return Object.keys(target).reduce(function (props, key) {
            props[key] = _this.cloneDeep(target[key]);
            return props;
        }, {});
    };
    return NrfNestedFormService;
}());
NrfNestedFormService.decorators = [
    { type: core.Injectable },
];
NrfNestedFormService.ctorParameters = function () { return []; };
var NrfFormDirective = /** @class */ (function () {
    function NrfFormDirective(nestedFormService, templateRef, viewContainerRef, el, renderer) {
        this.nestedFormService = nestedFormService;
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        this.el = el;
        this.renderer = renderer;
        if (!this.nestedFormService) {
            this.nestedFormService = new NrfNestedFormService();
        }
    }
    Object.defineProperty(NrfFormDirective.prototype, "nrfEntity", {
        get: function () {
            return this.nestedFormService.entity;
        },
        set: function (entity) {
            if (this.nestedFormService.entity !== entity) {
                this.nestedFormService.entity = entity;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NrfFormDirective.prototype, "formData", {
        get: function () {
            return this.nestedFormService.formData;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NrfFormDirective.prototype, "nrfSubmit", {
        get: function () {
            return this.nestedFormService.submit$;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NrfFormDirective.prototype, "formGroup", {
        get: function () {
            return this.nestedFormService.formGroup;
        },
        enumerable: true,
        configurable: true
    });
    NrfFormDirective.prototype.ngOnInit = function () {
        if (!this.nrfEntity) {
            this.nrfEntity = {};
        }
        this.renderView();
    };
    NrfFormDirective.prototype.ngOnDestroy = function () {
        this.nrfSubmit.complete();
    };
    NrfFormDirective.prototype.renderView = function () {
        var _this = this;
        if (this.templateRef && this.viewContainerRef) {
            var embeddedViewRef = this.viewContainerRef.createEmbeddedView(this.templateRef);
            var formNative = embeddedViewRef.rootNodes[0];
            this.renderer.listen(formNative, 'submit', function (event) { return _this.formSubmitWrapper(event); });
        }
    };
    NrfFormDirective.prototype.formSubmitWrapper = function ($event) {
        $event.preventDefault();
        if (!this.formGroup.valid) {
            return;
        }
        this.nrfSubmit.emit({
            nrfForm: this,
            formData: this.formData,
            entity: this.nrfEntity,
            formGroup: this.formGroup,
            event: $event,
        });
    };
    return NrfFormDirective;
}());
NrfFormDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[nrfForm]',
                exportAs: 'nrfForm',
            },] },
];
NrfFormDirective.ctorParameters = function () { return [
    { type: NrfNestedFormService, decorators: [{ type: core.Optional },] },
    { type: core.TemplateRef, decorators: [{ type: core.Optional },] },
    { type: core.ViewContainerRef, decorators: [{ type: core.Optional },] },
    { type: core.ElementRef, },
    { type: core.Renderer2, },
]; };
NrfFormDirective.propDecorators = {
    "nrfEntity": [{ type: core.Input },],
    "nrfSubmit": [{ type: core.Output },],
    "formSubmitWrapper": [{ type: core.HostListener, args: ['submit', ['$event'],] },],
};
var NrfFormModule = /** @class */ (function () {
    function NrfFormModule() {
    }
    return NrfFormModule;
}());
NrfFormModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                ],
                exports: [
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    NrfFormDirective,
                ],
                declarations: [
                    NrfFormDirective,
                ],
                providers: [
                    NrfNestedFormService,
                ],
            },] },
];
var NrfModelSetterService = /** @class */ (function () {
    function NrfModelSetterService() {
        var _this = this;
        this.getTargetPropToSet = function (obj, key, i, pathPieces) {
            var nextKey = pathPieces[i + 1];
            var isLast = nextKey == null;
            nextKey = nextKey || pathPieces['finalKey'];
            var isArrayKey = _this.isArrayKey(nextKey);
            var prop = obj[key];
            if (!prop) {
                prop = isArrayKey ? [] : {};
                obj[key] = prop;
            }
            else if (isLast) {
                prop = isArrayKey ? __spread(prop) : Object.assign({}, prop);
                obj[key] = prop;
            }
            return prop;
        };
    }
    NrfModelSetterService.prototype.getValue = function (path, model, separator) {
        if (separator === void 0) { separator = '.'; }
        if (path == null || !model) {
            return null;
        }
        try {
            var pathPieces = this.generatePathPieces(path, separator);
            return pathPieces.reduce(this.piecesReducer, model) || null;
        }
        catch (err) {
            return null;
        }
    };
    NrfModelSetterService.prototype.piecesReducer = function (obj, key) {
        return key === '' ? obj.slice(-1)[0] : obj[key];
    };
    NrfModelSetterService.prototype.setValue = function (path, value, model, separator) {
        if (separator === void 0) { separator = '.'; }
        if (!(path && model)) {
            return null;
        }
        try {
            var pathPieces = this.generatePathPieces(path, separator);
            var finalKey = pathPieces.pop();
            ((pathPieces))['finalKey'] = finalKey;
            var targetProp = pathPieces.reduce(this.getTargetPropToSet, model) || null;
            if (finalKey === '') {
                targetProp.push(value);
            }
            else {
                targetProp[finalKey] = value;
            }
        }
        catch (err) {
            console.error('NestedProps setValue error: ', err);
        }
    };
    NrfModelSetterService.prototype.isArrayKey = function (key) {
        return key === '' || !isNaN(parseInt(key, 10));
    };
    NrfModelSetterService.prototype.generatePathPieces = function (path, separator) {
        return path
            .replace('[', separator)
            .replace(']', '')
            .split(separator);
    };
    return NrfModelSetterService;
}());
NrfModelSetterService.decorators = [
    { type: core.Injectable },
];
var NrfNestedControlContext = /** @class */ (function () {
    function NrfNestedControlContext(formControl, formGroup, nrfNestedControl) {
        this.formControl = formControl;
        this.formGroup = formGroup;
        this.nrfNestedControl = nrfNestedControl;
        this.$implicit = formControl;
    }
    return NrfNestedControlContext;
}());
var NrfNestedControlDirective = /** @class */ (function () {
    function NrfNestedControlDirective(modelSetter, nestedFormService, templateRef, viewContainerRef) {
        this.modelSetter = modelSetter;
        this.nestedFormService = nestedFormService;
        this.templateRef = templateRef;
        this.viewContainerRef = viewContainerRef;
        this.ready$ = new core.EventEmitter();
        this.isRegisteredToFormControl = false;
        this.isDestroyed = false;
    }
    NrfNestedControlDirective.prototype.ngOnInit = function () {
        this.modelPath = this.getModelPathWithoutFirstPart();
        this.registerToFormGroup();
        this.subscribeToValueChanges();
        this.showViewContent();
        this.emitReadyState();
    };
    NrfNestedControlDirective.prototype.ngOnDestroy = function () {
        this.isDestroyed = true;
        this.ready$.complete();
        if (this.parentFormGroup) {
            this.parentFormGroup.removeControl(this.nrfModelName);
        }
    };
    NrfNestedControlDirective.prototype.showViewContent = function () {
        var context = new NrfNestedControlContext(this.formControl, this.parentFormGroup, this);
        this.viewContainerRef.createEmbeddedView(this.templateRef, context);
    };
    NrfNestedControlDirective.prototype.registerToFormGroup = function () {
        if (this.isRegisteredToFormControl) {
            return;
        }
        var formGroup = this.getFormGroup();
        var formControl = this.getFormControl(formGroup);
        this.formControl = formControl;
        if (formGroup) {
            this.isRegisteredToFormControl = true;
            this.parentFormGroup = formGroup;
            formGroup.addControl(this.nrfModelName, formControl);
        }
    };
    NrfNestedControlDirective.prototype.getFormGroup = function () {
        if (this.nestedFormService) {
            return this.nestedFormService.formGroup;
        }
        return new forms.FormGroup({});
    };
    NrfNestedControlDirective.prototype.getFormControl = function (formGroup) {
        var formControl = formGroup && (formGroup.get(this.nrfModelName));
        if (!formControl) {
            formControl = this.getNewFormControl();
        }
        return formControl;
    };
    NrfNestedControlDirective.prototype.getNewFormControl = function () {
        var initialValue = this.getInitialValue();
        return new forms.FormControl(initialValue || null);
    };
    NrfNestedControlDirective.prototype.subscribeToValueChanges = function () {
        var _this = this;
        this.formControl.valueChanges
            .pipe(operators.takeWhile(function () { return !_this.isDestroyed; }))
            .subscribe(function (newValue) { return _this.setModelValue(newValue); });
    };
    NrfNestedControlDirective.prototype.getModelPathWithoutFirstPart = function () {
        return this.nrfModelName.substr(this.nrfModelName.indexOf('.') + 1);
    };
    NrfNestedControlDirective.prototype.getInitialValue = function () {
        if (this.nestedFormService) {
            return this.modelSetter.getValue(this.modelPath, this.nestedFormService.formData);
        }
        return null;
    };
    NrfNestedControlDirective.prototype.setModelValue = function (newValue) {
        if (this.nestedFormService) {
            return this.modelSetter.setValue(this.modelPath, newValue || '', this.nestedFormService.formData);
        }
    };
    NrfNestedControlDirective.prototype.emitReadyState = function () {
        this.ready$.emit(true);
    };
    return NrfNestedControlDirective;
}());
NrfNestedControlDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[nrfNestedControl]',
                exportAs: 'nrfNestedControl',
            },] },
];
NrfNestedControlDirective.ctorParameters = function () { return [
    { type: NrfModelSetterService, },
    { type: NrfNestedFormService, decorators: [{ type: core.Optional },] },
    { type: core.TemplateRef, },
    { type: core.ViewContainerRef, },
]; };
NrfNestedControlDirective.propDecorators = {
    "nrfModelName": [{ type: core.Input, args: ['nrfNestedControl',] },],
    "ready$": [{ type: core.Output },],
};
var NrfModelModule = /** @class */ (function () {
    function NrfModelModule() {
    }
    return NrfModelModule;
}());
NrfModelModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [],
                providers: [
                    NrfModelSetterService,
                    NrfNestedFormService,
                ],
                declarations: [
                    NrfNestedControlDirective,
                ],
                exports: [
                    NrfNestedControlDirective,
                ],
            },] },
];
var NrFormsModule = /** @class */ (function () {
    function NrFormsModule() {
    }
    return NrFormsModule;
}());
NrFormsModule.decorators = [
    { type: core.NgModule, args: [{
                exports: [
                    NrfFormModule,
                    NrfModelModule,
                ],
                providers: [
                    NrfNestedFormService,
                ]
            },] },
];

exports.NrFormsModule = NrFormsModule;
exports.NrfFormDirective = NrfFormDirective;
exports.NrfNestedControlContext = NrfNestedControlContext;
exports.NrfNestedControlDirective = NrfNestedControlDirective;
exports.NrfModelSetterService = NrfModelSetterService;
exports.NrfNestedFormService = NrfNestedFormService;
exports.ɵa = NrfFormModule;
exports.ɵb = NrfModelModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=webdev-tools-ng-nested-reactive-forms.umd.js.map
